Codeforces Round #460 (Div. 2) D. Substring(树形dp)

时间:2022-09-20 16:02:31
D. Substring
time limit per test
3 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

You are given a graph with n nodes and m directed edges. One lowercase letter is assigned to each node. We define a path's value as the number of the most frequently occurring letter. For example, if letters on a path are "abaca", then the value of that path is 3. Your task is find a path whose value is the largest.

Input

The first line contains two positive integers n, m (1 ≤ n, m ≤ 300 000), denoting that the graph has n nodes and m directed edges.

The second line contains a string s with only lowercase English letters. The i-th character is the letter assigned to the i-th node.

Then m lines follow. Each line contains two integers x, y (1 ≤ x, y ≤ n), describing a directed edge from x to y. Note that x can be equal to y and there can be multiple edges between xand y. Also the graph can be not connected.

Output

Output a single line with a single integer denoting the largest value. If the value can be arbitrarily large, output -1 instead.

Examples
input
5 4
abaca
1 2
1 3
3 4
4 5
output
3
input
6 6
xzyabc
1 2
3 1
2 3
5 4
4 3
6 4
output
-1
input
10 14
xzyzyzyzqx
1 2
2 4
3 5
4 5
2 6
6 8
6 5
2 10
3 9
10 9
4 6
1 10
2 8
3 7
output
4
Note

In the first sample, the path with largest value is 1 → 3 → 4 → 5. The value is 3 because the letter 'a' appears 3 times.


题意:n个点,m条边,每个点对应字符串位置的字母,一条路径的权值等于这条路径上最大相同字母的个数,求路径的最大权(当权值不固定,即出现环的时候输出-1)

可以把整个图看做一颗树,然后每个节点存储由它为起点的路径中每个字母出现的最大次数,回溯刷新最大值即可

dp[i][j]表示以i为起点的所有路径中字母j+'a'最大出现了多少次

#include<bits/stdc++.h>
using namespace std;
#define Accel ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
const int N=3e5+500;
vector<int>g[N];
string s;
int vis[N],dp[N][26];
void dfs(int u)
{
    vis[u]=1;
    dp[u][s[u-1]-'a']=1;
    for(int i=0;i<g[u].size();i++)
    {
        int v=g[u][i];
        if(vis[v]==1)
        {
            cout<<"-1";
            exit(0);
        }
        else
        {
            if(!vis[v])dfs(v);
            for(int k=0;k<26;k++)
                dp[u][k]=max(dp[u][k],dp[v][k]+(s[u-1]-'a'==k));
        }
    }
    vis[u]=2;
}
int u,v,ans,n,m;
int main()
{
    Accel;
    cin>>n>>m>>s;
    for(int i=0;i<m;i++)
    {
        cin>>u>>v;
        g[u].push_back(v);
    }
    for(int i=1;i<=n;i++)
    {
        if(!vis[i])
        {
            dfs(i);
            for(int j=0;j<26;j++)
                ans=max(ans,dp[i][j]);
        }
    }
    cout<<ans;
    return 0;
}